$typecheck on
$include "rapidq.inc"

$define  rqIsNum   1
$define  rqIsChar  2
$define  rqIsUdt   3

const rqWord   = 2
const rqInt    = 4
const rqLong   = 4
const rqSingle = 4
const rqDouble = 8

'Flag
const rqNil = 255         
const rqYes = 1
   
dim buf as qMemoryStream
defbyte spare
 
type aStack extends QObject
    private:
    stash as QMemoryStream         'Stores values and objects
    bytes as QMemoryStream         'Stores sizes as word
    tags as QMemoryStream          'Stores what..?! (Variable names)
    ' For fixed types stores {maxindex, itemtype}, otherwise
    ' stores each type as a byte
    id as QMemoryStream

    public:
    fixedType as byte property set fixmode   'Flag for typed stack
    
    private:
    with this
    subi addNum(...)
        'ParamVal(1): value, paramVal(2): numtype-> 'rqInt, etc.
        .stash.writeNum(paramVal(1), paramVal(2))
        if .fixedType = rqNil then
            'Random
            .bytes.WriteNum( paramVal(2), 2)
            .id.writeNum(rqIsNum, 1)
        else
            .id.position = 0
            'Current count
            .id.writeNum(.stash.size \ paramVal(2), 2)
        end if
    end subi
        
    sub addStr(s as string, len$ as word)
        .stash.writeStr(s, len$) 
        if .fixedType = rqNil then
            .bytes.writeNum(len$, 2)
            .id.writeNum(rqIsChar, 1)
        else
            .id.position = 0
            .id.writeNum(.stash.size\len$, 2)
        end if    
    end sub     
     
    sub addUDT(u as long, bytes% as integer)
        'Stores a copy of values..!
        .stash.memCopyFrom(u, bytes%)
        if .fixedType = rqNil then
            .bytes.writeNum(bytes%, 2)      'Word
            .id.writeNum(rqIsUdt, 1)
        else    
            .id.position = 0
            .id.writeNum(.stash.size\bytes%, 1)        'byte
        end if    
    end sub    
    
    sub getUDT(count as word)
        'External memory buffer
        buf.size = count      'Exact space
        buf.position = 0           
        .stash.memCopyTo(buf.pointer, count)
    end sub
    
    function getItem(i_type as byte, i_size as integer) as variant
        'print "Type  "; i_type; ". Size  "; i_size
        select case i_type
        case rqIsNum
            'Some number
            result = .stash.readNum(i_size)  
        case rqIsChar
            'String
            result = .stash.readStr(i_size)  
        case rqIsUdt
            .getUDT(i_size )
            result = 1       'Sucessfull get 
        end select       
    end function
    end with
        
    public:
    'Public properties
    numLength as word  property set setNumber
    strLength as word  property set setString
    '----------------------------------
    function maxIndex  as integer
    'It could be .id.size for "stack mode" (see above)
    with this
      result = .id.size           'Items count (ramdom mode)
      if .fixedType = rqYes  then
        'print "Checking maxindex.. (array mode)"
        .id.position = 0
        result = .id.readNum(2)
      end if
    end with    
    end function
 
    '----------------------------------    
    function istype as integer
    with this
        ' 0 = random type
        .id.position = 2
        result = iif(.fixedType = rqNil, 0, .id.readNum(1))
    end with    
    end function

    '++++++++++++++++++++++++++++++++++++++++++++++++++
    functioni add(...) as integer
        result = 0   'Fail
        
        'First parameter can be a number or a string
        'The other two must be numbers: not always required.
        ' string, number, number
        ' number, number, number
        
        defword paramCount = paramValCount + paramStrCount
        if paramCount=0  or paramCount > 3 or paramStrCount>1 then
            print "Error in parameters.. _
                   Use: (num,num,num) or (str,num,num)"
            exit functioni
        end if
      
        defbyte itemtype
        defword itemlen
        with this
        if .fixedType = rqYes then
            .id.position = 2 : itemtype = .id.readNum(1)
            .bytes.position = 0 : itemlen = .bytes.readNum(2)
        end if    
        .id.position = .id.size         'Ready for append
        .stash.position = .stash.size   'Also
        
        select case paramStrCount
        case 0
            'A number. It could be a pointer
            'Protect. 
            if .fixedType=rqYes and itemtype = rqIschar then  exit functioni
                
            select case paramValCount
            case 1
                'add(value). Default: word  (unsigned integer)
                .addNum(paramVal(1), .numLength)
            case 2,3
                'add(value, size[, type]).
                'Handle value as a number
                select case paramVal(2)
                case is <= 0
                    print "Null length..?"
                    exit functioni
                case else   ' > 0
                    if .fixedType = rqNil  then
                        'Accept it
                    elseif itemlen <> paramVal(2) then
                        'Reject
                        exit functioni
                    end if    
            
                    if paramValCount = 2 then
                        .addNum(paramVal(1), paramVal(2))
                    else    
                        select case paramVal(3)
                        case is <= 0
                            'We cannot handle it as a default type because
                            '[value] could be an address..!
                            print "Null type..?"
                            'Unforgivable
                            exit functioni
                        case else
                            if .fixedType = rqNil  then
                                'Accept it
                            elseif itemtype <> paramVal(3) then
                                'Reject
                                exit functioni
                            end if    
                                
                            select case paramVal(3)
                            case rqIsNum
                                .addNum(paramVal(1), paramVal(2))
                            case rqIsUdt   
                                'ParamVal(1) must be a pointer                        
                                .addUdt(paramVal(1), paramVal(2))
                            end select
                        end select '3
                    end if  '2
                end select '2,3
                
                'First call (Also valid for UDTs)
                if .fixedType=rqYes and .maxindex()= 0  _
                    then  .numlength = paramVal(2)
            case else
                'Ignore
                exit functioni
            end select '1       
        case 1               'Only
            'We know that there is a string
            'Protect
            if .fixedType=rqYes and itemtype <> rqIsChar _
                then exit functioni
            'Store
            select case paramVal(1)
            case is <= 0, 255
            'print "Adding.. ";  paramStr$(1) 
                'It wasn't passed or it was rqNil  
                .addstr(paramStr$(1), _
                  iif( .fixedType = rqYes, .strlength, len(paramStr$(1))) )
            case else
                .addstr(paramStr$(1), paramVal(1))
                'First call..?
                if .maxindex() = 0  then  .strlength = paramVal(1) 'Fix it 
            end select      
        case else
            'ParamStr(2) ? . This isn't implemented
            print "Error in parameters.. Assuming string"
            .addstr(paramStr$(1), .strlength)     'Ummmh..
        end select 
        end with
        
        'Then
        result = 1
    end functioni 

    '+++++++++++++++++++++++++++++++++++++++++++
    functioni set(...) as integer
    'Sintax .set(index[,numvalue][,chrvalue])
    'First parameter is the number of item to be overwritten
    'the second parameter will be the value ( a variable or constant )

    if paramValCount = 0  then  exit functioni     'No index !
    if paramVal(1) <= 0  then  exit functioni      'Wrong index

    with this
    if paramVal(1) > .maxindex() then
        print "Upper bound error.."
        exit functioni
    end if    
    defint index = paramVal(1)            'Target
    defbyte itemtype : defword itemsize
     
    'Prepare
    .bytes.position = 0

    if .fixedType = rqYes  then
        .id.position = 2 : itemtype = .id.readNum(1)
        itemsize = .bytes.readNum(2)
        .stash.position = (index-1)* itemsize
    else
        'Search for it    
        .id.position = 0
        .stash.position = 0
                
        defint __j = 1 
        do
            itemtype = .id.readnum(1)        'A byte Eeh..!
            itemsize = .bytes.readNum(2)
            if __j = index then
                result = -1                  'Yes !
                exit do 
            end if    
            
            if .id.position = .id.size  then
                print "Upper Bound error.."
                result = index               'Info
                exit functioni
            end if    
                
            'Delayed advance (skip the item)
            .stash.position = .stash.position + itemsize
            inc(__j)
        loop
    end if     

    'Do the job
    'print "Type: "; itemtype; "  Size: "; itemsize
    select case itemtype 
      case rqIsNum
        'Integer
        'print paramVal(2); " at index "; index 
        .stash.writeNum(paramVal(2), itemsize)
      case rqIsChar
        'String
        defstr s = Left$(paramStr$(1) & space$(itemsize), itemsize)
        .stash.writeStr(s, itemsize)   
      case rqIsUdt
        if paramVal(2) <= 0  then 
            result = 0
        else 
            'We must be SURE that paramVal(2) is a valid pointer   
            .stash.memCopyFrom(paramVal(2), itemsize)
        end if    
    end select       
    end with
    end functioni                                  

    '+++++++++++++++++++++++++++++++++++++++++++++++++++++
    'Read at position
    function get( itemnum as integer, inf as long) as variant
        'inf must be a pointer used to return type value
        if this.maxindex() = 0  then
            print "The object is empty.. "; itemnum
            exit function 
        end if
        
        'Capture this mistake
        if itemnum <= 0  then  exit function
        
        'Find it
        with this
        if .fixedType <> rqNil then
            if itemNum > .maxindex()  then
                print "Upper bound error.."; itemnum
                exit function
            end if
            
            'Obtain by pointer arithmetic
            .bytes.position = 0    

            defword itemsize = .bytes.readNum(rqWord)
            .stash.position = (itemnum-1) * itemsize
            .id.position = 2          ' id: {maxindex, type}  
            result = .getItem(.id.readNum(1), itemsize)
        else
            'Process    
            .stash.position = 0
            .id.position = 0   
            .bytes.position = 0
                
            defint __j = 1, __bytes
            defbyte __type
            'Sequential search
            do
                __type = .id.readNum(1)
                __bytes = .bytes.readNum(2)

                'Write to a external variable
                if inf>0  then memcpy(inf, varptr(__type), 1) 
                     
                result = .getItem(__type, __bytes)
                'print result
                if __j = itemnum then
                    exit functioni 
                end if    
            
                if .id.position = .id.size  then
                    print "Upper Bound error.."
                    result = itemnum
                    exit functioni
                end if    
                
                inc(__j)
            loop
        end if     
        end with
    end function    
    
    '+++++++++++++++++++++++++++++++++++++++++++++++++++
    function pop(mode as byte, what as long ) as variant
      defbyte  __type          'Do what is it?
      defword  atoms           'Items' elements count 

      'Remove (1), or checks (0) the last object
      with this
      if  .stash.size = 0 then
        print "The stack is empty.. "' : sleep 5
        end             '
        'exit function 
      end if  
      end with
        
      'print what
      'Go to tail item
      with this.id
      .position = iif(this.fixedType = rqYes, 2, .size-1)
      __type = .readNum(1)
      'print "type was: "; __type
      end with
      
      with this.bytes
      .position = iif(this.fixedType = rqYes, 0, .size - 2)
      atoms = .readNum(2)
      end with
      
      with this.stash
      .position = .size - atoms
      end with
    
      'Get it
      with this
      result = .getItem( __type, atoms)
      
      ' Type's info
      if what > 0  then  memcpy(what, varptr(__type), 1)    
    
      if mode = 1  then          'True
        'print "Removig last object.."
        'Remove it
        .stash.size = .stash.size - atoms
        if .fixedType = rqNil then
            .id.size    = .id.size - 1
            .bytes.size = .bytes.size - 2
        else
            defword count = .maxindex()
            .id.position = 0
            .id.writeNum(count, 2)   'Redundant information
        end if
        'print "stash len: "; .stash.size; " maxitem: "; .maxindex()
      end if  
      end with
    end function  

    '---------------------------------    
    subi dima(...)
        'All parameters are numbers
        'ParamVal(1)    -> dimension
        'ParamVal(2)    -> type
        'ParamVal(3)    -> size of "object"
                'Etc..
        'Uniform array. See add(...) function for non-uniform one

        if this.fixedtype = rqNil and this.maxindex() > 0 then
          print "Can't redim a random type array..!"
          exit subi
        end if 
        
        if paramStrCount <> 0 then  exit subi 'Ignore the call
        if paramValCount = 0  then  exit subi

        with this
        'Status.
        defword count = .maxindex()
        defint valtype = .istype()
        defbyte fresh = .fixedType=rqNil and count=0
        .bytes.position = 0
        defint itemsize = iif(fresh, 0, .bytes.readNum(2))
                
        'print "Begin redim.."
        select case paramValCount
        case 1
            ' dima(n). Guess type and preserve
            'Default: array of numbers
            select case ParamVal(1)
            case 0     
                ' "Kill" any array but preserving the type
                .bytes.position = 0
                .id.position = 0
                .id.writeNum(0, 2)  'Zero to count

                if count > 0 then   'It is not fresh neither random
                    'To wipe out
                    .stash.size = 0
                elseif fresh  then   
                    'Fresh stack
                    'print "New empty numeric array.." 
                    .id.writeNum(rqIsNum, 1)
                    .bytes.writeNum(.numlength, 2)
                end if    
            case is > 0
                'Default:  array of word
                'Preserve it
                if fresh then
                    'New
                    .stash.size = paramVal(1)* .numLength

                    'Clean
                    defword n
                    .stash.position = 0
                    for n=1 to paramVal(1)
                        .stash.WriteNum(0, .numLength)
                    next    
                    
                    'Status
                    .bytes.position = 0
                    .bytes.writeNum(.numlength, 2)
                    'Avoid mistakes
                    .id.writeNum(rqIsNum, 1)  'The default
                else      
                    select case valtype
                    case rqISnum, rqIsChar, rqIsUdt
                        'Redim with the same size for item
                        .stash.size = paramVal(1)* itemsize
                    case else
                        'Undefined type
                        exit subi
                    end select        
                end if
                'Count is stored as a word (it can be integer.., etc.)
                .id.position = 0 : .id.writeNum(paramVal(1),2) 
            end select    'ParamVal(1)
        case is >= 2
            ' dima(n, type [, size])
            'A type was specified
            select case paramVal(2)
            case rqIsNum, rqIsChar, rqIsUdt  'Maybe others!
                'Accept
            case else
                'Avoid troubles
                exit subi
            end select        
            defbyte requiredType = paramVal(2)
            print "Type: "; valtype; " Required type: "; paramVal(2)
                            
            select case paramVal(1)    'New count
            case 0
                if paramVal(3) < 0   then  exit subi 'What? 
                .stash.size = 0
                .id.position =0 : .id.writeNum(0,2)  'count to 0
                .bytes.position = 0
                
                select case valtype
                case 0
                    'Obviouly a new container
                    select case requiredtype
                    case rqIsNum
                        .bytes.writeNum( _
                          iif( ParamVal(3) = 0, .numlength, ParamVal(3)), 2)
                    case rqIsChar      
                        .bytes.writeNum( _
                          iif( ParamVal(3) = 0, .strlength, ParamVal(3)), 2)
                    case rqIsUdt
                        'Nothing happens if zero
                        if paramVal(3) > 0  then
                            .bytes.WriteNum( ParamVal(3), 2)
                        end if 
                    end select       
                                  
                    'Must be set.. 
                    .id.writeNum(requiredType, 1)
                case is > 0
                    'Preserve type
                    'Ignore third parameter if it is there
                end select
            case is > 0         
                'print "There is a count..! "; paramVal(1)
                'sleep 2
                if fresh  then
                    'print "First time.."
                    'New  (build it)
                    if paramVal(3) > 0 then
                        'Size.. Must check for any mistake
                        defword objSize = paramVal(3)
                      
                        select case requiredType
                        case rqIsNum
                           if objSize < 2  then
                               exit subi
                           end if
                        case rqIsChar
                            if objSize < 8  then
                                exit subi
                            end if    
                        case else
                            'Initialize other types (or abort)
                            'exit subi
                        end select
                      
                        'OK
                        'print "Size: "; objsize 
                        itemsize = objSize
                    else
                        'print "Guessing type size.. Size: "; itemsize
                        'A size for the item wasn't specified
                        select case itemsize
                        case 0
                            select case requiredtype
                            case rqIsNum
                                itemsize = .numlength
                            case rqIsChar 
                                itemsize = .strlength
                            case else
                                print "Size of object missed.."
                                exit subi
                            end select    
                        case else
                            'Redim
                        end select    
                    end if     

                    'Do it
                    .stash.size = paramVal(1)* itemsize
                    .bytes.position = 0 : .bytes.writeNum(itemsize, 2)
                        
                    'print "Storing size: "; itemsize 
                    'print "Storing type: ";requiredtype
                    .id.position = 0 
                    .id.writeNum(paramVal(1), 2)
                    .id.writeNum(requiredType, 1)
                    'New end. We can initialize new space here, but 
                    'that is coumbersome..!
                else 
                    'We have a type already          
                    if valtype <> requiredType then
                      'Reject. Type cannot be changed..!
                      exit subi
                    end if   
                     
                    '...then, Adjust it
                    .id.position = 0 
                    .id.writeNum(paramVal(1), 2)
                    
                    'Items cannot be resized
                    .stash.size = paramVal(1) * itemsize
                end if  'Fresh
            end select
        end select            

        'Protect the array
        'print "Protect it.."
        if .fixedType = rqNil  then .fixedType  = rqYes
        end with
    end subi
    
    property set fixmode(mode as byte)
      with this
      'Do it only when the container is empty
      if .maxindex() = 0 then 
        select case mode
        case rqNil, rqYes
            .fixedType = mode
            
            if mode = rqNil  then     ' Random
                .id.size = 0 : .bytes.size=0  
            end if    
        case else
            'Ignore.. Some message..?    
        end select    
      end if  
      end with
    end property   
   
    property set setString( chrCount as word )
        with this
        if .maxindex() = 0 then     'Only at init time or after dima(0)
            .strlength = chrCount
        end if    
      end with
    end property

    property set setNumber( bytes as word )
      with this
        if .maxindex() = 0 then     'Idem            
            .numlength = bytes
        end if    
      end with  
    end property
   
    constructor
    numLength = rqWord       'Bytes
    strlength = 16           'Characters 
    fixedType = rqNil
    end constructor
end type    
